; ***************************************
; *                                     *
; * C64 viewer for 4x4 Texture Designer *
; *      written by Laze Ristoski       *
; *                                     *
; ***************************************
; Source written for ACME crossassembler

                !to "viewer.prg"
                *=$0801

flag            = 2
storeA          = 3

                !raw $0b, $08, $d3, $07, $9e
                !raw $32, $30, $36, $34, 0, 0, 0, 0, 0, 0

                sei
                lda #$35
                sta $01
                ldx #$ff
                txs
                lda #$7f
                sta $dc0d
                sta $dd0d
                lda $dc0d
                lda $dd0d
                lda #0
                sta $d011
                sta $d015
                sta $d01b
                sta $d01c
                sta $d01d
                sta $d020
                sta $d021
                lda #$ff
                sta $d017

                ldx #$40
                lda #$ff
createsprite    sta $6800,x
                dex
                bpl createsprite

                ldy #7
                lda #0
                sta $d027,y
                dey
                bpl *-4

                ldx #5
                lda pos,x
                sta $d000,x
                dex
                bpl *-7
                
                ldx #0
                lda #$f0
createbmp       sta $4000,x
                sta $4100,x
                sta $4200,x
                sta $4300,x
                sta $4400,x
                sta $4500,x
                sta $4600,x
                sta $4700,x
                sta $4800,x
                sta $4900,x
                sta $4a00,x
                sta $4b00,x
                sta $4c00,x
                sta $4d00,x
                sta $4e00,x
                sta $4f00,x
                sta $5000,x
                sta $5100,x
                sta $5200,x
                sta $5300,x
                sta $5400,x
                sta $5500,x
                sta $5600,x
                sta $5700,x
                sta $5800,x
                sta $5900,x
                sta $5a00,x
                sta $5b00,x
                sta $5c00,x
                sta $5d00,x
                sta $5e00,x
                sta $5f00,x
                inx
                bne createbmp

copycolor       lda color1,x
                sta $6000,x
                lda color1+$100,x
                sta $6100,x
                lda color1+$200,x
                sta $6200,x
                lda color1+$300,x
                sta $6300,x

                lda color2,x
                sta $6400,x
                lda color2+$100,x
                sta $6500,x
                lda color2+$200,x
                sta $6600,x
                lda color2+$300,x
                sta $6700,x
                inx
                bne copycolor

                ldx #7
                lda #$a0
                sta $63f8,x
                sta $67f8,x
                dex
                bpl *-7

                lda #7
                sta $d015

                ldx #0
                lda #$80
initbank        sta bank,x
                inx
                eor #$10
                sta bank,x
                eor #$10
                inx
                bne initbank

                ldx #0
                lda #$3b
initbadline     sta badline,x
                clc
                adc #4
                and #7
                ora #$38
                inx
                bne initbadline

                lda #$80
                sta $d018
                lda #$c8
                sta $d016
                lda #$96
                sta $dd00

                lda #0
                sta flag

                lda #<nmi
                ldx #>nmi
                sta $fffa
                stx $fffb

                lda #0
                sta $dd05
                lda #10
                sta $dd04
                lda #$81
                sta $dd0d
                lda #$19
                sta $dd0e

                lda #1 
                cmp flag
                bne *-2

                lda #<irq
                ldx #>irq
                sta $fffe
                stx $ffff
                lda #$30
                sta $d012
                lda #1
                sta $d01a
                lda $d011
                bpl *-3
                lda #$3f
                sta $d011
                dec $d019
                cli
endless         jmp endless

nmi             lda #1
                sta flag
                rti

irq             sta storeA
                inc $d012
                lda #<irq2
                ldx #>irq2
                sta $fffe
                stx $ffff
                dec $d019
                cli
                nop
                nop
                nop
                nop
                nop
                nop
                nop
                nop
                jmp *-8

irq2            pla
                pla
                pla

                ldx #6
                dex
                bne *-1
                bit $00
                   
                lda $d012
                cmp $d012
                beq *+2

                ldx #9
                dex
                bne *-1
                nop

                ldx #0
loop            lda bank,x
                sta $d018
                lda badline,x
                sta $d011
                ldy #34
                dey
                bne *-1
                bit $00
                inx
                lda bank,x
                sta $d018
                lda badline,x
                sta $d011
                ldy #33
                dey
                bne *-1
                inx
                cpx #30
                bne loop

                lda bank,x
                sta $d018
                lda badline,x
                sta $d011
                ldy #30
                dey
                bne *-1
                nop
                inx

                lda $d001
                clc
                adc #126
                sta $d001
                lda $d003
                adc #126
                sta $d003

                lda bank,x
                sta $d018
                lda badline,x
                sta $d011
                ldy #34
                dey
                bne *-1
                inx

loop2           lda bank,x
                sta $d018
                lda badline,x
                sta $d011
                ldy #34
                dey
                bne *-1
                bit $00
                inx
                lda bank,x
                sta $d018
                lda badline,x
                sta $d011
                ldy #33
                dey
                bne *-1
                inx
                cpx #50
                bne loop2

                ldx #5
                lda pos,x
                sta $d000,x
                dex
                bpl *-7

                lda #<irq
                ldx #>irq
                sta $fffe
                stx $ffff
                lda #$30
                sta $d012
                dec $d019
                lda storeA
                rti

; ---------------------------------------------------------------------------                

pos             !raw $18, $32, $18, $5c, $18, $86
color1          = *
color2          = *+1000
bank            = $c000
badline         = $c100
